Unit TestAD;
{ ========================================================================== }
{ =   Lynx Tecnologia Eletrnica Ltda.                                     = }
{ =   Projeto:   Drivers LynxDAS para o AqDados 7       Data: 14/mai/2002  = }
{ =   Programa:  Exemplo de uso do LynxDAS.DLL                             = }
{ =   Mdulo:    TestAD                                                    = }
{ =   Autor:     Lauro                                                     = }
{ =   Descrio: Teste da entradas analgicas por WFF.                     = }
{ =   Verso:    1.0                                                       = }
{ ========================================================================== }

{-------------------------  Descrio da Interface  -------------------------}
Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     ExtCtrls, StdCtrls, Buttons, Spin, ComCtrls;


{ ===================================================== }
{ =               Declarao de tipos                 = }
{ ===================================================== }

Type
  TdlgTestAD = class (TForm)
    btClose    : TBitBtn;
    gbTableAD  : TGroupBox;
    cbFaixa_0  : TComboBox;
    cbFaixa_1  : TComboBox;
    cbFaixa_2  : TComboBox;
    cbFaixa_3  : TComboBox;
    seCanal_0  : TSpinEdit;
    seCanal_1  : TSpinEdit;
    seCanal_2  : TSpinEdit;
    seCanal_3  : TSpinEdit;
    panValBin_0: TPanel;
    panValBin_1: TPanel;
    panValBin_2: TPanel;
    panValBin_3: TPanel;
    panValTen_0: TPanel;
    panValTen_1: TPanel;
    panValTen_2: TPanel;
    panValTen_3: TPanel;
    panStatus  : TPanel;
    panTiBin   : TPanel;
    panTiCanal : TPanel;
    panTiFaixa : TPanel;
    panTiTensao: TPanel;
    tmrUpdate  : TTimer;
    Procedure FormCreate (Sender: TObject);
    Procedure FormClose (Sender: TObject; var Action: TCloseAction);
    Procedure tmrUpdateTimer (Sender: TObject);
  private
    { Private declarations }
    Procedure Leitura (Canal, iFaixa: smallint; panBinario, panTensao: TPanel);
  public
    { Public declarations }
  end;


{ ===================================================== }
{ =                Variveis globais                  = }
{ ===================================================== }

  Var dlgTestAD: TdlgTestAD;


{-------------------------  Descrio da Implementao ----------------------}
Implementation
  Uses LDASapi;

{$R *.DFM}


{ ========================================================================== }
{ =                  Implementao do objeto TdlgTestAD                    = }
{ ========================================================================== }

{------------------------------------------- TdlgTestAD: Cria o dialog box --}
Procedure TdlgTestAD.FormCreate (Sender: TObject);
  Var i   : smallint;
      sAux: string;
begin
  cbFaixa_0.Clear;
  cbFaixa_1.Clear;
  cbFaixa_2.Clear;
  cbFaixa_3.Clear;
  for  i := 0 to Pred (nAiRange)  do
  begin
    if  AiRange [i] < 0  then
      sAux := Format ('%.5g a %.5g V', [AiRange [i], -AiRange [i]])
    else
      sAux := Format ('0 a %.5g V', [AiRange [i]]);
    cbFaixa_0.Items.Add (sAux);
    cbFaixa_1.Items.Add (sAux);
    cbFaixa_2.Items.Add (sAux);
    cbFaixa_3.Items.Add (sAux);
  end;

  cbFaixa_0.ItemIndex := 0;
  cbFaixa_1.ItemIndex := 1;
  cbFaixa_2.ItemIndex := 2;
  cbFaixa_3.ItemIndex := 3;
  seCanal_0.Value     := 0;
  seCanal_1.Value     := 1;
  seCanal_2.Value     := 2;
  seCanal_3.Value     := 3;
  tmrUpdate.Enabled   := false;
end;

{------------------ TdlgTestAD: Inibe o timer antes de fechar o dialog box --}
Procedure TdlgTestAD.FormClose (Sender: TObject; var Action: TCloseAction);
begin
  tmrUpdate.Enabled := false;
end;

{---------- TdlgTestAD: Realiza leitura de um canal A/D e atualiza display --}
Procedure TdlgTestAD.Leitura (Canal, iFaixa: smallint; panBinario, panTensao:TPanel);
  Var vBin   : smallint;
      vVolt  : single;
      m      : single;
      Range  : single;
begin
  if  LDAS_ReadAi (Canal, iFaixa, vBin)
  then begin
    panStatus.Caption  := '';
    panBinario.Caption := IntToStr (vBin);
    Range := AiRange [iFaixa];
    if  Range  < 0  then {  bipolar ? }
      vVolt := -Range / 32768.0 * vBin
    else begin
      m     := (Range - 0) / 65536.0;
      vVolt := m * (vBin + 32768.0);
    end;
    panTensao.Caption := Format ('%8.4f', [vVolt]);
  end
  else begin
    panStatus.Caption  := 'Erro no conversor A/D!';
    panBinario.Caption := '';
    panTensao.Caption  := '';
  end;
end;

{----------------- TdlgTestAD: Realiza leitura dos canais A/D selecionados --}
Procedure TdlgTestAD.tmrUpdateTimer (Sender: TObject);
begin
  Leitura (seCanal_0.Value, cbFaixa_0.ItemIndex, panValBin_0, panValTen_0);
  Leitura (seCanal_1.Value, cbFaixa_1.ItemIndex, panValBin_1, panValTen_1);
  Leitura (seCanal_2.Value, cbFaixa_2.ItemIndex, panValBin_2, panValTen_2);
  Leitura (seCanal_3.Value, cbFaixa_3.ItemIndex, panValBin_3, panValTen_3);
end;

end.
