Attribute VB_Name = "LDASapi"
' ============================================================================
' =   Lynx Tecnologia Eletrnica Ltda.                                       =
' =   Projeto:   Drivers LynxDAS para o AqDados 7       Data: 14/mai/2002    =
' =   Mdulo:    LDASapi                                                     =
' =   Autor:     Lauro                                                       =
' =   Descrio: Exemplo de uso do LynxDAS.DLL                               =
' =   Verso:    1.0                                                         =
' ============================================================================

' =====================================================
' =              Declarao de constantes             =
' =====================================================

  '----------------------------------------- ieXXXX: Interrupt error status --
  Public Const ieNoError = 0            ' Nenhum erro
  Public Const ieDriver = 100           ' Erro de acesso ao driver
  Public Const ieAcqStop = 101          ' Aquisio no est ativa
  Public Const ieBufSize = 102          ' Dimenso errada do buffer



' ============================================================================
' =                         Declarao de Tipos                              =
' ============================================================================

  Type TpAiRange
    Range(0 To 15) As Single
  End Type
  
  Public Const cBufSize = 16384   ' Tamanho do buffer em amostras
  Type TpUserBuf
    Buffer(0 To cBufSize - 1) As Integer
  End Type



' ============================================================================
' =                   Primitivas da biblioteca LynxDAS.DLL                   =
' ============================================================================

'--------------------------  Abre o acesso ao driver de aquisio de sinais --
Declare Function LDAS_OpenDriver Lib "LynxDAS.DLL" (ByVal szDrvName As String) As Byte

'------------------------------------------------- Fecha o acesso ao driver --
Declare Sub LDAS_CloseDriver Lib "LynxDAS.DLL" ()

'-----------------------------------------------  Abre o acesso  placa A/D --
Declare Function LDAS_OpenAccess Lib "LynxDAS.DLL" () As Byte

'-------------------------------------------- Finaliza o acesso  placa A/D --
Declare Sub LDAS_CloseAccess Lib "LynxDAS.DLL" ()

'------------------------------------------------- Obtm a verso do driver --
Declare Function LDAS_GetVersion Lib "LynxDAS.DLL" _
        (Version As Byte, Release As Byte) As Byte

'----------------------- Obtm os recursos de entrada analgica disponveis --
Declare Function LDAS_GetAiCaps Lib "LynxDAS.DLL" _
        (nAiChannels As Integer, nAiRange As Integer, _
         AiRange As TpAiRange) As Byte

'----------------------------- Obtm os recursos de E/S digital disponveis --
Declare Function LDAS_GetDioCaps Lib "LynxDAS.DLL" _
        (nDiPorts As Integer, nBitsDi As Integer, _
         nDoPorts As Integer, nBitsDo As Integer) As Byte

'------------------------------------------------ Limpa a memria de canais --
Declare Sub LDAS_ClearCM Lib "LynxDAS.DLL" ()

'---------------------------------------- Insere canal na memria de canais --
Declare Function LDAS_InsertAiCM Lib "LynxDAS.DLL" _
        (ByVal Channel As Integer, ByVal iRange As Integer) As Byte

'------------------------------ Insere entrada digital na memria de canais --
Declare Function LDAS_InsertDiCM Lib "LynxDAS.DLL" _
        (ByVal Group As Integer) As Byte

'---------------------------------- Preparao da aquisio por interrupo --
Declare Function LDAS_AcquisitionSetup Lib "LynxDAS.DLL" _
        (SampleFreq As Single) As Byte

'--------------------------------------- Inicia a aquisio por interrupo --
Declare Function LDAS_StartAcquisition Lib "LynxDAS.DLL" () As Byte

'------------------------------------- Finaliza a aquisio por interrupo --
Declare Sub LDAS_StopAcquisition Lib "LynxDAS.DLL" ()

'----------------------------- Leitura das amostras aquisitadas pelo driver --
Declare Function LDAS_GetSamplesVB Lib "LynxDAS.DLL" _
        (ieStatus As Long, nSamples As Long, nSampGot As Long, _
         iLast As Long, UserBuf As TpUserBuf) As Byte

'------------------------------------ Leitura de canal de entrada analgica --
Declare Function LDAS_ReadAi Lib "LynxDAS.DLL" _
        (ByVal Channel As Integer, ByVal iRange As Integer, _
         Value As Integer) As Byte

'--------------------------------------- Leitura de port de entrada digital --
Declare Function LDAS_ReadDi Lib "LynxDAS.DLL" _
        (ByVal Group As Byte, Value As Integer) As Byte

'----------------------------------------- Escrita em port de sada digital --
Declare Function LDAS_WriteDo Lib "LynxDAS.DLL" _
        (ByVal Group As Integer, ByVal Value As Integer) As Byte


Public fMainForm As frmMain


Sub Main()
    Set fMainForm = New frmMain
    fMainForm.Show
End Sub



